
import { Component, OnInit, Input, Output, EventEmitter, ViewContainerRef, ViewChild, OnDestroy, AfterViewInit } from '@angular/core';
import { AppEnvironment } from 'src/environments/AppEnvironment';
import { Subject, Subscription } from 'rxjs';
import { NzNotificationService } from 'ng-zorro-antd/notification';
import { Util } from '@global/util/util';
import { NzModalService } from 'ng-zorro-antd/modal';
import { Router, ActivatedRoute } from '@angular/router';
import { CodeList } from '@global/service/codelist/CodeList';
import { AppMenuControl } from '@global/service/control/AppMenuControl';


import { AppIndexViewAppMenuMode } from './app-index-view-appmenu.mode';

import { Http } from '@global/http/http';


@Component({
	selector: 'view_appmenu',
	templateUrl: './app-index-view-appmenu.html',
	styleUrls: ['./app-index-view-appmenu.less'],
})
export class AppMenu extends AppMenuControl implements OnInit, OnDestroy, AfterViewInit {




    /**
     * 构造方法
     * @memberof AppIndexView
     */
    constructor(
        private $ctrlMode: AppIndexViewAppMenuMode,
        private $util: Util, private $modal: NzModalService,
        private $router: Router, private $route: ActivatedRoute, 
        private $notice: NzNotificationService,
        private $codelist: CodeList
        
        , private $http: Http
    ) {
        super();
	}

    /**
     * 获取部件模型
     *
     * @memberof AppIndexView
     */
    public getControlMode() {
        return this.$ctrlMode;
    }


    /**
     * 生命周期（页面加载完成）
     *
     * @memberof Grid
     */
    ngAfterViewInit(): void {
    }

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof AppIndexView
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof AppIndexView
     */
    public getData(): any {
        return null;
    }

    /**
     * api地址
     *
     * @private
     * @type {string}
     * @memberof AppIndexView
     */
    private url: string = 'cn.ibizlab.demo/ctrl/appindexviewappmenu';

    /**
     * 应用功能集合
     *
     * @type {any[]}
     * @memberof AppIndexView
     */
    public appFuncs: any[] = [
    ];


    /**
     * 获取请求地址
     *
     * @returns {string}
     * @memberof AppMenuService
     */
    public getUrl(): string {
        return this.url;
    }

    /**
     * 获取请求对象
     *
     * @returns {Http}
     * @memberof AppMenuService
     */
    public getHttp(): Http {
        return this.$http;
    }

    /**
     * 生命周期
     *
     * @private
     */
	ngOnInit() {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.load(data);
            });
        }
	}

    /**
     * 菜单点击
     *
     * @private
     * @param {*} item 菜单数据
     * @memberof AppIndexView
     */
    private click(item: any) {
        if (item) {
            switch (item.appfunctag) {
                default:
                    console.warn('未指定应用功能');
            }
        }
    }


}
